Index: etc/rc.d/powerd
===================================================================
RCS file: /cvsroot/src/etc/rc.d/powerd,v
retrieving revision 1.2
diff -u -p -r1.2 powerd
--- etc/rc.d/powerd	13 Aug 2004 18:08:03 -0000	1.2
+++ etc/rc.d/powerd	1 May 2010 19:38:20 -0000
@@ -12,6 +12,37 @@ $_rc_subr_loaded . /etc/rc.subr
 name="powerd"
 rcvar=$name
 command="/usr/sbin/${name}"
+start_precmd='powerd_precmd'
+
+# mimic apmd(8) behaviour: run AC adapter script on startup
+powerd_precmd()
+{
+	local dmesg=/var/run/dmesg.boot
+	local envstat=/usr/sbin/envstat
+	local acad= acads=
+
+	[ -f "$dmesg" -a -x "$envstat" ] || return 0
+
+	# get list of adapters
+	acads="$(while read line; do
+	    case "$line" in
+	        acpiacad[0-9]*\ at\ acpi[0-9]*) echo "${line%% *}" ;;
+	    esac; done <"$dmesg")" || return 0
+	[ "$acads" ] || return 0 # no adapters found
+
+	# get adapter status and run script accordingly
+	for acad in $acads; do
+	case "$("$envstat" -s "$acad:connected" 2>/dev/null | \
+	    { read line; # ignore header
+	      read line; # ignore device name
+	      read sensor status; echo $status; })" in
+		ON)  /etc/powerd/scripts/acadapter "$acad" pressed ;;
+		OFF) /etc/powerd/scripts/acadapter "$acad" released ;;
+	esac
+	done
+
+	return 0
+}
 
 load_rc_config $name
 run_rc_command "$1"
